
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JSP的运行原理 / iVAN</title>

    <meta name="description" content="JSP的运行原理 昨天花了很多时间弄清了JSP的运行原理,总的来说,JSP就是封装好了的Servlet.不信的话请往下看: 首先你得弄清楚为什么后缀名为jsp的文件就能运行,原因很简单,因为Tomcat已经配置好了,配置文件是Tomcat的conf目录下的web.xml,打开该文件找到如下代码: 1 &lt;servlet-mapping&gt; 2 &lt;servlet-name&gt;jsp&lt;/servlet-name&gt; 3 &lt;url-pattern&gt;.jsp&lt;/url-pat ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JSP的运行原理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　　昨天花了很多时间弄清了JSP的运行原理，总的来说，JSP就是封装好了的Servlet。不信的话请往下看：</p>
<p>　　首先你得弄清楚为什么后缀名为jsp的文件就能运行，原因很简单，因为Tomcat已经配置好了，配置文件是Tomcat的conf目录下的web.xml，打开该文件找到如下代码：</p>
<pre><code>1     &lt;servlet-mapping&gt;
2         &lt;servlet-name&gt;jsp&lt;/servlet-name&gt;
3         &lt;url-pattern&gt;.jsp&lt;/url-pattern&gt;
4     &lt;/servlet-mapping&gt;
5     &lt;servlet-mapping&gt;
6         &lt;servlet-name&gt;jsp&lt;/servlet-name&gt;
7         &lt;url-pattern&gt;.jspx&lt;/url-pattern&gt;
8     &lt;/servlet-mapping&gt;</code></pre>
<p>这里就是Tomcat配置好的，由上面的URL可以知道，后缀名无论是jsp还是jspx都可以运行，甚至还可以自己更改，比如把<em>.jspx改成</em>.aaa，在Tomcat下的aaa文件就能被运行。这是问什么呢？*.jsp这一句就是配置URL的，只要URL中输入的是jsp文件，就会通过jsp，找到名为jsp的servlet,web.xml中还有这么一段代码：
<pre><code>1 &lt;servlet&gt;
 2         &lt;servlet-name&gt;jsp&lt;/servlet-name&gt;
 3         &lt;servlet-class&gt;org.apache.jasper.servlet.JspServlet&lt;/servlet-class&gt;
 4         &lt;init-param&gt;
 5             &lt;param-name&gt;fork&lt;/param-name&gt;
 6             &lt;param-value&gt;false&lt;/param-value&gt;
 7         &lt;/init-param&gt;
 8         &lt;init-param&gt;
 9             &lt;param-name&gt;xpoweredBy&lt;/param-name&gt;
10             &lt;param-value&gt;false&lt;/param-value&gt;
11         &lt;/init-param&gt;
12         &lt;load-on-startup&gt;3&lt;/load-on-startup&gt;
13 &lt;/servlet&gt;</code></pre>
<p>然后由servlet名找到servlet-class，即<br />
org.apache.jasper.servlet.JspServlet，JspServlet就是一个Servlet,它继承了<br />
HttpServlet，所以jsp文件能够被运行。JspServlet类可以到Tomcat源文件里面去找，这里不再详讲。</p>
<p>　　然后再讲一讲JSP的运行过程，当jsp文件第一次被运行时它会被编译成一个java文件，然后再将这个java文件编译成class文件(这<br />
些文件放在tomcat的work目录下)。要注意的是一个jsp文件只能被编译一次，也就是第一次运行的时候被编译，以后只要这个Jsp文件没有修改就<br />
不会再编译了。比如说在tomcat里面新建了一个demo.jsp,当这个jsp被运行的时候就会被编译成demo_jsp.java和<br />
demo_jsp.class。demo_jsp这个类继承了HttpJspBase，HttpJspBase也是一个servlet，它继承了<br />
HttpServlet,它的代码如下：</p>
<pre><code> 1 package org.apache.jasper.runtime;
 2
 3 import java.io.IOException;
 4
 5 import javax.servlet.ServletConfig;
 6 import javax.servlet.ServletException;
 7 import javax.servlet.http.HttpServlet;
 8 import javax.servlet.http.HttpServletRequest;
 9 import javax.servlet.http.HttpServletResponse;
10 import javax.servlet.jsp.HttpJspPage;
11 import javax.servlet.jsp.JspFactory;
12
13 import org.apache.jasper.compiler.Localizer;
14
15 /
16   This is the super class of all JSP-generated servlets.
17
18   @author Anil K. Vijendran
19  /
20 public abstract class HttpJspBase
21     extends HttpServlet
22     implements HttpJspPage
23
24
25 {
26
27     protected HttpJspBase() {
28     }
29
30     public final void init(ServletConfig config)
31     throws ServletException
32     {
33         super.init(config);
34     jspInit();
35         _jspInit();
36     }
37
38     public String getServletInfo() {
39     return Localizer.getMessage(“jsp.engine.info”);
40     }
41
42     public final void destroy() {
43     jspDestroy();
44     _jspDestroy();
45     }
46
47     /
48       Entry point into service.
49      /
50     public final void service(HttpServletRequest request, HttpServletResponse response)
51     throws ServletException, IOException
52     {
53         _jspService(request, response);
54     }
55
56     public void jspInit() {
57     }
58
59     public void _jspInit() {
60     }
61
62     public void jspDestroy() {
63     }
64
65     protected void _jspDestroy() {
66     }
67
68     public abstract void _jspService(HttpServletRequest request,
69                      HttpServletResponse response)
70     throws ServletException, IOException;
71 }</code></pre>
<p>HttpJspBase这个类重写了HttpServlet的service方法，而没有重写doGet()或者doPost()(通过URL运行<br />
的默认是GET方式提交)，因为首先调用的是service方法，而这个方法里面又调用了_jspService()方法，HttpJspBase类中<br />
_jspService()方法是抽象方法，但是demo1_jsp这个类重写了这个方法，所以就调用了demo1_jsp类中的<br />
_jspService()方法。以上就足以证明，JSP就是servlet了。</p>
<p>　　JSP中可以直接写HTML标签，又可以直接嵌入JAVA程序，java程序段写在&lt;% %&gt;或者&lt;%!<br />
%&gt;里面，但是写在&lt;% %&gt;和写在&lt;%! %&gt;里又有什么不同呢？&lt;%!<br />
%&gt;里面是定义变量或者函数用的，写在这里面的会定义成demo1_jsp类中的成员变量或成员函数。而写在&lt;%<br />
%&gt;里面的则在_jspService()方法里直接输出了。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-16 04:54:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/web%e5%90%8e%e7%ab%af/" title="web后端">web后端</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JSP的运行原理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdgxkz.html" rel="bookmark">JSP程序运行原理、文档结构及简单输入输出实例分析&lowbar;JSP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JSP程序运行原理.文档结构及简单输入输出.分享给大家供大家参考.具体如下: 目标: 掌握Web应用的文档结构: 掌握JSP的运行原理: 掌握JSP的简单输入和输出. 主要内容: 通过一个简单实例介绍Web应用的文档结构和运行原理: 通过一个简单的注册功能介绍基本的输入输出. 实现内容:客户端验证. 1. 文档结构 每个应用都有一个根目录,例如ch2:理论上可以放在任何地方,但是需要配置,简单的做法,直接放在了webapps这个目录下,在这个目录的应用会被自动加载. 在根目录下会有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/dzZAmop.html" rel="bookmark">JSP的运行内幕</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js 经常有朋友问起,JSP和Servlet之间有什么区别,两者之间又有什么联系?其实Servlet技术的出现时间很早,是当时为了Java的服务器端应用而开发的.大家都知道Applet是应用小程序,Servlet就是服务器端小程序了.但在Microsoft公司的ASP技术出现后,使用Servlet进行响应输出时一行行的输出语句就显得非常笨拙,对于复杂布局或者显示页面更是如此.JSP就是为了满足这种需求在Servlet技术之上开发的.可见,JSP和Servlet之间有着内在的血缘关系,在学习JSP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoeZjb.html" rel="bookmark">spring的运行机制或者运行原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 最近碰到的这个问题,在网上搜了下,基本上的答案要么是说的SpringMVC的,要么说的是IOC跟AOP的概要,有没有准确一点的答案,望大神指点一二 解决方案 内部最核心的就是IOC了, 动态注入,让一个对象的创建不用new了,可以自动的生产,这其实就是利用java里的反射 反射其实就是在运行时动态的去创建.调用对象,Spring就是在运行时,跟xml Spring的配置 文件来动态的创建对象,和调用对象里的方法的 . Spring还有一个核心就是AOP这个就是面向切面编程,可以为某一类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqDBXRb.html" rel="bookmark">JSP的运行内幕&lowbar;JSP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    经常有朋友问起,JSP和Servlet之间有什么区别,两者之间又有什么联系?其实Servlet技术的出现时间很早,是当时为了Java的服务器端应用而开发的.大家都知道Applet是应用小程序,Servlet就是服务器端小程序了.但在Microsoft公司的ASP技术出现后,使用Servlet进行响应输出时一行行的输出语句就显得非常笨拙,对于复杂布局或者显示页面更是如此.JSP就是为了满足这种需求在Servlet技术之上开发的.可见,JSP和Servlet之间有着内在的血缘关系,在学习JS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9A4yoM.html" rel="bookmark">Web Service 运行原理详细介绍&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     利用清明小假期,温习了一遍Web Service的相关内容,对其工作原理进行了简要总结.以供有需求的朋友和自己日后参考.文章若有不当之处,敬请朋友们提出宝贵建议,以求共勉.       Web服务中,我们应该首先了解相关的术语含义:WSDL.UDDI....相关术语方面的介绍在此不再赘述,重点放在原理上. 在Web服务中,存在三个角色:服务提供者.服务请求者和服务中介,三者之间的关系如图1-1所示     实现一个完整的Web服务包括以下步骤:    ◆ Web服务提供者设计实现Web			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7M07yPb.html" rel="bookmark">快速建立Servlet和JSP的运行、调试和编译环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|servlet|编译 相信很多刚开始学习Servlet和JSP的朋友都有一个困扰,就是如何快速方便的建立一个Servlet和JSP的运行.调试和编译环境.本人现在正在国外攻读MIT(Master of Information Technology),现在选修的这一科是WBIS(Web Based Information Systems),其包含了许多种技术,如Java,Perl,CGI,Servlet,ASP,Java Script,JSP,OO,UML等等.下面的这篇文章是学校所提供的相			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boG03b.html" rel="bookmark">JSP的运行环境配置方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js Sun推出的JSP(Java Server Pages)是一种执行于服务器端的动态网页开发技术,它基于Java技术.执行JSP时需要在Web服务器上架设一个编译JSP网页的引擎.配置 JSP 环境可以有多种途径,但主要工作就是安装和配置Web服务器和JSP引擎. 下面就以Tomcat作为JSP引擎,配合Tomcat.Apache.IIS这三种Web服务器来讲述3种搭建JSP运行环境的方案. 一.相关软件介绍 1. J2SDK:Java2的软件开发工具,是Java应用程序的基础.JSP是基于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7Aa2z.html" rel="bookmark">保存一个JSP文件运行是出错用的myeclipse</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 保存一个JSP文件运行是出错用的myeclipse W ception in thread &quot;&quot;main&quot;&quot; java.lang.NoClassDefFoundError: org/apache/juli/logging/LogFactory at org.apache.catalina.startup.Bootstrap.(Bootstrap.java:52)Caused by: java.lang.ClassNotFoundException: org			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPx58p.html" rel="bookmark">C&plus;&plus; 学习之旅一&mdash;&mdash;Windows程序内部运行原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				      学习C++与.net不同的是,一定要搞清楚Windows程序内部运行原理,因为他所涉及大多数是操作系统的调用,而.net毕竟是在.netFrameWork上唱戏.        那Windows应用程序,操作系统,计算机硬件之间的相互关系究竟什么了,下面的图就给予很好的解释.       向下箭头①是 应用程序运行判断处理的结果,输出到输出的设备.       向上箭头②是输入设备,输入到操作系统中.       向下箭头③代表API,我们要解释以下API是什么.API是应用程序接口			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boWvbv.html" rel="bookmark" class="title">113期：电子书《阿里巴巴技术实战2016年刊》重磅发布，免费下载！</a>
					<div>
						本期头条   • [资料合集]首届阿里开源峰会回顾:讲义PDF+活动视频! • [在线峰会]即将直播:大数据技术峰会 • 微博红包技术最佳实践:架构及运维 • 阿里开源数据库AliSQL最佳实践    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvGvrp.html" rel="bookmark" class="title">jquery eas&period;&period;&period;-easyui是如何加载easyui&period;css文件中没有的css样式的？</a>
					<div>
						问题描述 easyui是如何加载easyui.css文件中没有的css样式的? easyui是如何加载easyui.css文件中没有的css样式的? 比如,我用jquery去生成一个linkbutto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKwExp.html" rel="bookmark" class="title">基于MEF的插件框架的总体设计</a>
					<div>
						1.MEF框架简介 MEF的全称是Managed Extensibility Framework(MEF),其是.net4.0的组成部分,在3.5上也可以使用.熟悉java中的spring框架的人,对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7yK8M.html" rel="bookmark" class="title">Photoshop绘制一个玻璃温度计图标技巧</a>
					<div>
						温度计构造不复杂,不过玻璃容器部分刻画比较难.因为它的轮廓不是很规则,刻画同一部分的高光及暗部的时候需要分两步或多步来完成. 最终效果 &lt;图1&gt; 1.温度计图标大致由下面的几部分构成:玻璃 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7xq7M.html" rel="bookmark" class="title">javascript的propertyIsEnumerable&lpar;&rpar;方法使用介绍</a>
					<div>
						 propertyIsEnumerable()是用来检测属性是否属于某个对象的,如果检测到了,返回true,否则返回false,下面为大家介绍下其具体的使用  代码如下: /*  propertyIs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eQ1Lb.html" rel="bookmark" class="title">win7系统下如何对U盘背景图片进行修改设置</a>
					<div>
						  我们经常使用Windows系统的用户来说,很多Windows系统的图片.模式的已经习惯,比如无论是Windows下的文件夹还是插入u盘后打开的文件夹,其背景图案都是空白的,当有人和小编提起这件事时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWyZAp.html" rel="bookmark" class="title">新浪微博微彩票如何根据粉丝投票的结果进行投注？</a>
					<div>
						  发起投票的用户或参与投票的用户可在当前期的投注截止前或截止后,依据投票结果选择号码投注当前期; 通过粉丝投票,您可以了解当天或当期,哪些号码(或比赛结果)最受您的好友追捧,而哪些又最受冷遇.通过分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjnWWb.html" rel="bookmark" class="title">Android Easeui 3&period;0 即时通讯的问题汇总&lowbar;Android</a>
					<div>
						 0.关于注册账号就不用说了. 1.创建应用.获取appkey 0.创建应用 1.填写信息 2.获取appkey 2.集成 0.首先新建一个工程 1.这里主要介绍使用easeui来集成环信的即时通讯功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGADvvM.html" rel="bookmark" class="title">rsa-VB代码编写RSA加密的问题</a>
					<div>
						问题描述 VB代码编写RSA加密的问题 布局老是提示被除数为0代码Private Function jiami(ByVal mingwen1 As Long ByRef miwen1 As Long) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3QYdz.html" rel="bookmark" class="title">关于javascript修改二级菜单display属性的问题</a>
					<div>
						问题描述 关于javascript修改二级菜单display属性的问题 网页的主体是菜单,二级菜单是隐藏的,以下为一个&quot;书籍&quot;菜单的代码.其中二级菜单的高的数值比一级菜单的要大,所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKLv8b.html" rel="bookmark" class="title">如何恢复一个已破坏的OfficeWord文档</a>
					<div>
						如果文档打开不正常,可以使用 如下几种办法来恢复其中保存的所有或者大部分信息: (1). 复制到新的文档.可以拷贝文档中除了最后一个段落标志之外的所有对象至一个新的文档.Word在段落标志中保存大量信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR079b.html" rel="bookmark" class="title">oc-OC链表问题不知道我理解的是否正确</a>
					<div>
						问题描述 OC链表问题不知道我理解的是否正确 //学生结构体 typedef struct student{ unsigned int num;//学号 char name[20]; //姓名 cha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94nxkb.html" rel="bookmark" class="title">xml-关于安卓设置按钮回退到上一个activity的问题 ，问下大神两种方法的不同。</a>
					<div>
						问题描述 关于安卓设置按钮回退到上一个activity的问题 ,问下大神两种方法的不同. 1.第一种是常规的添加按钮监听,使用finish回退到上一个activit运行成功. 2.查资料后,还有一种解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEYxvM.html" rel="bookmark" class="title">盘点2017汉诺威工业展上IT厂商的10款物联网新品</a>
					<div>
						汉诺威工业展览会(Hannover Messe)是每年在德国举行的工业自动化盛会,今年物联网服务和产品成为关注焦点. IT厂商渴望向工厂客户和制造商客户展示他们新的物联网服务,以及与运营技术公司新建立 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydQq8b.html" rel="bookmark" class="title">ORACLE uuid自动生成主键</a>
					<div>
						-- Create table create table TECHNOLOGYCOMPANY ( ID VARCHAR2(32) default SYS_GUID() not null, FLOWID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnROr2p.html" rel="bookmark" class="title">ORM对象关系映射已成为炙手可热的技术</a>
					<div>
						简单映射,是对象关系映射中最为简单的一种,也是最为基础的一种,学好简单映射是掌握继承映射,关联关系映射的前提所在. 近年来 ORM(Object-Relational Mapping,对象关系映射,即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKdDLp.html" rel="bookmark" class="title">细数云计算产品和技术-OpenStack</a>
					<div>
						简介 OpenStack是一个开源的云计算管理平台项目,由几个组件组合起来完成具体工作.OpenStack支持几乎所有类型的云环境,提供实施简单.可大规模扩展.丰富.标准统一的云计算管理平台.Open ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4ePKNb.html" rel="bookmark" class="title">风险：成本膨胀和监管措施</a>
					<div>
						高盛集团今天公布研究报告,将好未来 (NYSE: XRS )的股票评级维持在&quot;买入&quot;(Buy)不变,目标价30美元. 以下是报告内容摘要: 业绩超出预期:教室利用率提高推动毛利率上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0A7GM.html" rel="bookmark" class="title">C&num;中grawbeziers的使用，错误在哪里？</a>
					<div>
						问题描述 usingSystem;usingSystem.Collections.Generic;usingSystem.ComponentModel;usingSystem.Data;usingSy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXal5b.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;System&period;Data&period;SqlClient&period;SqlCommand&rdquo;并不包含CreateCommand对象，我现在急死了，完不成项目就去跳河去了，大家帮我啊！</a>
					<div>
						问题描述 protectedvoidButton1_Click(objectsender,EventArgse){SqlConnectionmyConnection=newSqlConnection( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoOXxM.html" rel="bookmark" class="title">ibatis 嵌套查询</a>
					<div>
						问题描述 我现在有一个表 X 里面有 三个属性 a b c 我想通过 查询表里的c属性得到 b ,再用得到的 b 属性去查 a.一般的SQL不是这样写吗? select a from x where  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0n5y6z.html" rel="bookmark" class="title">SQL Server 2005导出表中数据的SQL脚本形式</a>
					<div>
						CREATE   proc sp_GenInsertSQL (@tablename varchar(256))asbegindeclare @sql varchar(8000)declare @sql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN23Bp.html" rel="bookmark" class="title">有关3D打印你需要知道的一切</a>
					<div>
						11月18日消息,有关http://www.aliyun.com/zixun/aggregation/10949.html&quot;&gt;3D打印即将掀起一场新时代革命的说法已经愈演愈烈.那么3D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn88oKb.html" rel="bookmark" class="title">JS中attr和prop属性的区别以及优先选择示例介绍&lowbar;基础知识</a>
					<div>
						相比attr,prop是1.6.1才新出来的,两者从中文意思理解,都是获取/设置属性的方法(attributes和properties).只是,window或document中使用.attr()方法在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn80KWb.html" rel="bookmark" class="title">在openSUSE42&period;1下编译安装PHP7 的方法&lowbar;php实例</a>
					<div>
						首先推荐一篇文章PHP 7 Release Date Arrived: Will Developers Adopt PHP 7? - PHP Classes blog. 里面说到是否会去使用PHP7, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GJKJp.html" rel="bookmark" class="title">jquery实现无刷新验证邮箱地址</a>
					<div>
						今天在开发的时候.需要在一个用户验证邮箱.但是使用了传统的js无刷新需要清空浏览器缓存后才能正常的验证所以自己就去用jquery 去写一个了无刷新验证 看看  代码如下 复制代码 &lt;script ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOgR7b.html" rel="bookmark" class="title">仿windows xp左侧菜单伸缩效果js特效</a>
					<div>
						+网络配置中心 -站长手册 -动态域名 -DHCP服务 -ADSL设置 -MODEM设置 +安全配置中心 -入侵检测系统 -行为管理系统 -虚拟网系统 -防火墙系统 +系统报告中心 -系统状态 -网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2BeWM.html" rel="bookmark" class="title">救急，提交之前，环信聊天Crash</a>
					<div>
						问题描述 提交之前,环信聊天报错, 那里越界了吗?? debug版本,堆栈完全看不出来...大神救急!!!1. libc++abi.dylib: terminate_handler unexpecte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZm1wkp.html" rel="bookmark" class="title">c&num; 串口问题</a>
					<div>
						问题描述 c#串口通信中,采用winapi函数ClearCommError进行清除串口错误或者读取当前的串口的状态.本人采用两种声明方式:[1][System.Runtime.InteropServi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4BVOb.html" rel="bookmark" class="title">Reddit加入原创视频浪潮</a>
					<div>
						编者的话:从雅虎到 Hulu再到Netflix,原创内容成为了美国互联网行业掀起的热潮,而其中,视频原创更是一个热点中的热点.现在,在这股新浪潮里又多了一个竞争者,它就是Reddit. 不过,Redd ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
